#!/usr/bin/perl -w

use strict;
use POSIX qw(locale_h);
use locale;
use DBI;

setlocale(LC_ALL, "tr_TR");

# Ayarlar
# $store_method: Kullanlacak saklama yntemi.
# mysql ya da csv'den biri olabilir. Her yntemin ihtiya
# duyduu ayarlar farkl:
#   csv => dbdir: kelimeleri saklayacak CSV dosyasn bulunduracak dizin
#          table: kelimeleri saklayacak dosya ismi
#
#   mysql => dbhost: MySQL sunucusu
#            dbase : Veritaban ismi
#            dbuser: Sunucuya balanrken kullanlacak isim
#            dbpass: Sunucu parolas
#            table : Kelimelerin saklanaca tablo

######

my $store_method = "mysql";
my $dbhost = "localhost";
my $dbase = "sozluk";
my $dbuser = "user";
my $dbpass = "pass";
my $dbdir = "/path/to/sozluk";
my $table = "tbd_csv";
die ("altrmadan nce ayarlamalar yapn ve bu satr silin!!!\n");

######

if ($store_method eq "mysql") {
	$DBI::drh = DBI->install_driver("mysql");
	my @dbs = $DBI::drh->func($dbhost, "_ListDBs");

	my $have_db = "";
	foreach (@dbs) {
		if ($_ eq $dbase) {
			$have_db = 1;
		}
	}

	unless ($have_db) {
		$DBI::drh->func("createdb", $dbase, $dbhost, $dbuser, $dbpass, "admin")
			or die "db initialization error: " . $DBI::drh->errstr;
	}

	$DBI::dbh = DBI->connect("DBI:mysql:database=$dbase;host=$dbhost", $dbuser, $dbpass);
	$DBI::sth = $DBI::dbh->do("DROP TABLE IF EXISTS $table");

	$DBI::sth = $DBI::dbh->do(qq{
		CREATE TABLE $table (
			en VARCHAR(70) NULL default '',
			tr VARCHAR(70) NULL default '',
			KEY (en(20), tr(20)),
			KEY (tr(20), en(20))
		) TYPE=MyISAM
	});
} elsif ($store_method eq "csv") {
	$DBI::dbh = DBI->connect("DBI:CSV:f_dir=$dbdir");

	my (@list) = $DBI::dbh->func('list_tables');
	foreach (@list) {
		if ($table eq $_) {
			$DBI::dbh->do("DROP TABLE $table");
			last;
		}
	}
	$DBI::dbh->do("CREATE TABLE $table (en VARCHAR(70), tr VARCHAR(70))");
} else {
	print "Bilinmeyen saklama yntemi: $store_method\n";
	print "\$store_method deikeni sadece 'mysql' ya da 'csv' ";
	print "deerlerinden birini alabilir!\n";
	exit 1;
}

$DBI::sth = $DBI::dbh->prepare("INSERT INTO $table (en, tr) VALUES (?, ?)");
extract(<STDIN>);

$DBI::sth->finish();
$DBI::dbh->disconnect();

sub extract {
	my $word = "";
	my $count = 0;

	foreach (@_) {
		chomp();
		if (/valign=top/) {
			s/.*<td valign=top>([[:alnum:][:punct:] ]+)<\/td>.*/$1/i;
			s/^ *| *$//g;
			tr/A-Z/a-z/;
			if ($word eq "") {
				$word = $_;
			} else {
				$DBI::sth->execute($word, $_);
				$count++;
				$word = "";
			}
		}
	}
	print "$count kelime veritabanina yerlestirildi ($store_method).\n";
}
